﻿
'
'
'      _                      _____               _                _  _              
'     | |                    / ____|             | |              | || |             
'   __| | _ __  ___   _ __  | |      ___   _ __  | |_  _ __  ___  | || |  ___  _ __    
'  / _` || '__|/ _ \ | '_ \ | |     / _ \ | '_ \ | __|| '__|/ _ \ | || | / _ \| '__|   
' | (_| || |  | (_) || |_) || |____| (_) || | | || |_ | |  | (_) || || ||  __/| |     
'  \__,_||_|   \___/ | .__/  \_____|\___/ |_| |_| \__||_|   \___/ |_||_| \___||_|        
'                    | |                                                                               
'                    |_|                                                                               
'

'
' Reminders
' Set version in AssemblyInfo.vb file
' 



Imports System
Imports System.IO
Imports System.IO.Ports
Imports System.Reflection
Imports System.Drawing
Imports System.Text
Imports Microsoft.Win32



Public Class MainForm

    ' debug
    Dim DEBUG_MASTER As Boolean = False
    Dim DEBUG2 As Boolean = False




    Dim widthNormal As Integer = 844
    Dim widthDebug As Integer = 1110

    Dim comPORT As String
    Dim receivedData As String = ""


    Dim start_time As DateTime
    Dim stop_time As DateTime
    Dim elapsed_time As TimeSpan


    Dim timeOutTime As Long = 0



    ' __  __
    '|  \/  |                    
    '| \  / |  ___  _ __   _   _ 
    '| |\/| | / _ \| '_ \ | | | |
    '| |  | ||  __/| | | || |_| |
    '|_|  |_| \___||_| |_| \__,_|
    '



    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        AboutBox1.ShowDialog()
    End Sub



    Private Sub OnlineHelpToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OnlineHelpToolStripMenuItem.Click
        Try
            Process.Start("https://www.dropcontroller.com")
        Catch ex As Exception
            MsgBox("Can't load Web page" & vbCrLf & ex.Message)
        End Try
    End Sub




    Private Sub MainForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        CloseProgram()
    End Sub

    Private Sub ExitButton_BTN_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub


    ' mode, 1, 2 , 3
    '  Resume 1 	
    ' The operating system Is about To Resume from a suspended state.    

    ' StatusChange 	2 	
    ' A power mode status notification Event has been raised by the operating system. This might indicate a weak Or charging battery, a transition between AC power And battery, Or another change In the status Of the system power supply.

    ' Suspend 	3 	
    ' The operating system Is about To be suspended.

    Private Sub SystemEvents_PowerModeChanged(ByVal sender As Object, ByVal e As PowerModeChangedEventArgs)

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Power Mode Change. e.mode = " & e.Mode & vbCrLf)
        End If

        Select Case e.Mode

            Case PowerModes.Suspend
                'txtSuspend.Text = Now
                If (DEBUG_MASTER) Then
                    debugTextBox.AppendText("suspend = " & Now & vbCrLf)
                End If


            Case PowerModes.Resume
                ' txtResume.Text = Now
                If (DEBUG_MASTER) Then
                    debugTextBox.AppendText("resume = " & Now & vbCrLf)
                End If

        End Select

    End Sub




    '                    _         ______                        _                        _ 
    '                   (_)       |  ____|                      | |                      | |
    '  _ __ ___    __ _  _  _ __  | |__  ___   _ __  _ __ ___   | |      ___    __ _   __| |
    ' | '_ ` _ \  / _` || || '_ \ |  __|/ _ \ | '__|| '_ ` _ \  | |     / _ \  / _` | / _` |
    ' | | | | | || (_| || || | | || |  | (_) || |   | | | | | | | |____| (_) || (_| || (_| |
    ' |_| |_| |_| \__,_||_||_| |_||_|   \___/ |_|   |_| |_| |_| |______|\___/  \__,_| \__,_|
    '
    '

    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText(vbCrLf & "Program start" & vbCrLf)
        End If


        AddHandler SystemEvents.PowerModeChanged, AddressOf SystemEvents_PowerModeChanged

        Me.FormBorderStyle = FormBorderStyle.FixedSingle
        MaximizeBox = False

        If (DEBUG_MASTER = True) Then
            turnDebugOn()
        Else
            turnDebugOff()
        End If


        abort_BTN.Visible = False

        Me.Height = 600

        loadSettings()
        startBTNoff()
        PopulateCOMport()

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Initialised and ready to start" & vbCrLf & vbCrLf)
        End If

    End Sub




    Private Sub CloseProgram()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Program closing" & vbCrLf)
        End If

        closeValves()
        saveSettings()
        disconnect()
    End Sub














    '  _____                                  _            
    ' / ____|                                | |              
    '| |      ___   _ __   _ __    ___   ___ | |_    
    '| |     / _ \ | '_ \ | '_ \  / _ \ / __|| __|  
    '| |____| (_) || | | || | | ||  __/| (__ | |_   
    ' \_____|\___/ |_| |_||_| |_| \___| \___| \__|                                                            
    '                                                                                                                               
    ' After connecting wait for the user to click the start button
    '

#Region "Connect & Disconnect"

    Private Sub RefreshCOM_BTN_Click_1(sender As Object, e As EventArgs) Handles refreshCOM_BTN.Click
        PopulateCOMport()
    End Sub


    Private Sub PopulateCOMport()
        COMport_CB.Text = ""
        COMport_CB.Items.Clear()
        For Each sp As String In My.Computer.Ports.SerialPortNames
            COMport_CB.Items.Add(sp)
        Next

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("COM port list updated" & vbCrLf)
        End If

    End Sub


    Private Sub Connect_BTN_Click_1(sender As Object, e As EventArgs) Handles connect_BTN.Click

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("connect_BTN_Click" & vbCrLf)
            debugTextBox.AppendText("initial status -   SerialPort1.IsOpen= " & SerialPort1.IsOpen & vbCrLf)
        End If

        If (connect_BTN.Text = "CONNECT" And SerialPort1.IsOpen) Then

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("  connect_BTN.text = CONNECT & serial port is already open" & vbCrLf)
            End If

        End If



        If (connect_BTN.Text = "CONNECT") Then
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("  connect_BTN.text set to = CONNECT" & vbCrLf)
            End If

            If (COMport_CB.SelectedItem = "") Then
                connect_BTN.Text = "CONNECT"
                MsgBox("Select a COM port first", , "ERROR")

                If (DEBUG_MASTER) Then
                    debugTextBox.AppendText("  ERROR: No COM port selected" & vbCrLf)
                End If


            Else

                connect_BTN.Text = "Connecting..."
                connect_BTN.Enabled = False

                ' the timer takes care of the next bit
                ' without a timer, the button text change is too fast (or does not happen)
                timer_updateConnectButton.Enabled = True

            End If

        ElseIf (connect_BTN.Text = "DIS-CONNECT") Then
            abort()
            disconnect()
        End If

    End Sub



    Private Sub Timer_updateConnectButton_Tick(sender As Object, e As EventArgs) Handles timer_updateConnectButton.Tick

        ' this is used to change the CONNECT BUTTON text to "Connecting..."
        ' without a timer the text does not change.  The timer is set to 100ms

        timer_updateConnectButton.Enabled = False

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("timer_updateConnectButton_Tick" & vbCrLf)
        End If

        If (SerialPort1.IsOpen) Then
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("  Error: " & comPORT & " already open" & vbCrLf)
            End If
        End If


        comPORT = COMport_CB.SelectedItem

        If (Not SerialPort1.IsOpen) Then

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("  try to open serial port" & vbCrLf)
            End If

            SerialPort1.PortName = comPORT
            SerialPort1.BaudRate = 9600
            SerialPort1.DataBits = 8
            SerialPort1.Parity = Parity.None
            SerialPort1.StopBits = StopBits.One
            SerialPort1.Handshake = Handshake.None
            SerialPort1.Encoding = System.Text.Encoding.Default
            SerialPort1.ReadTimeout = 10000

            'Arduino Leonardo
            ' Not really sure if I need to separate this bit or just include for all models
            'SerialPort1.DtrEnable = True
            'SerialPort1.RtsEnable = True


            ' check if device is avaiable: 
            Try
                SerialPort1.Open()
            Catch ex As Exception
                connect_BTN.Text = "CONNECT"
                connect_BTN.Enabled = True

                If (DEBUG_MASTER) Then
                    debugTextBox.AppendText("  Failed to open" & comPORT & vbCrLf)
                    debugTextBox.AppendText("  Error = " & ex.Message & vbCrLf)
                End If

                MsgBox("Error. Cannot open COM port: " & ex.Message, MsgBoxStyle.Critical, "ERROR")
            End Try


        Else
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("  Error: " & comPORT & " already open" & vbCrLf)
            End If

        End If




        If (SerialPort1.IsOpen) Then

            SerialPort1.DiscardInBuffer()
            receivedData = ""

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("COM " & comPORT & " opened" & vbCrLf)
            End If



            'See if the dropController is there - send HELLO message and wait for a reply
            sendCommand("[HELLO]" & vbCrLf)

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("HELLO sent" & vbCrLf)
            End If


            ' start checkSerialData timer
            ' start connection timeout timer
            ' wait for a reply from the dropController or timeout if no reply received

            Timer_recieveSerialDataOn()
            Timer_ConnectionTimeoutON()


        End If

    End Sub






    Private Sub Timer_checkConnect_Tick(sender As Object, e As EventArgs) Handles Timer_ConnectionTimeout.Tick

        ' if this fires the HELLO message has not been  received
        ' show error message
        ' reset the buttons etc

        Timer_ConnectionTimeoutOFF()

        connect_BTN.Text = "CONNECT"
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("HELLO reply message not received from the dropController" & vbCrLf)
        End If

        MsgBox("ERROR!" & vbCrLf & "Cannot connect to the dropController")


        If (SerialPort1.IsOpen) Then
            SerialPort1.Close()

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("Serial port closed" & vbCrLf)
            End If

        End If

        populateCOMport()
        connect_BTN.Enabled = True

        Timer_recieveSerialDataOff()
    End Sub





    Private Sub disconnect()
        'close the connection a reset the button and timer labels

        Timer_ConnectionTimeoutOFF()


        If (SerialPort1.IsOpen) Then
            sendCommand("[BYE]")
            'SerialPort1.Write("<BYE>")
            closeValves()
            receivedData = ""
            SerialPort1.DiscardInBuffer()
            SerialPort1.Close()

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("COM port closed" & vbCrLf)
            End If

        End If

        connect_BTN.Text = "CONNECT"
        COMport_CB.Enabled = True
        refreshCOM_BTN.Enabled = True
        startBTNoff()
        'PopulateCOMport()


        disableValveDrainButtons()
        'connected = False



    End Sub




#End Region 'Region "Connect & Disconnect"
























    ' __      __     _  _      _         _           _    _                    _____                       _   
    ' \ \    / /    | |(_)    | |       | |         | |  | |                  |_   _|                     | |  
    '  \ \  / /__ _ | | _   __| |  __ _ | |_  ___   | |  | | ___   ___  _ __    | |   _ __   _ __   _   _ | |_ 
    '   \ \/ // _` || || | / _` | / _` || __|/ _ \  | |  | |/ __| / _ \| '__|   | |  | '_ \ | '_ \ | | | || __|
    '    \  /| (_| || || || (_| || (_| || |_|  __/  | |__| |\__ \|  __/| |     _| |_ | | | || |_) || |_| || |_ 
    '     \/  \__,_||_||_| \__,_| \__,_| \__|\___|   \____/ |___/ \___||_|    |_____||_| |_|| .__/  \__,_| \__|
    '                                                                                       | |                
    '                                                                                      |_|                

    Private Sub delay_TB_KeyPress(sender As Object, e As KeyPressEventArgs) Handles delay_TB.KeyPress
        If Asc(e.KeyChar) <> 13 AndAlso Asc(e.KeyChar) <> 8 AndAlso Not IsNumeric(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub

    Private Sub numDrops_TB_KeyPress(sender As Object, e As KeyPressEventArgs) Handles numDrops_TB.KeyPress
        If Asc(e.KeyChar) <> 13 AndAlso Asc(e.KeyChar) <> 8 AndAlso Not IsNumeric(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub

    Private Sub dropSize_TB_KeyPress(sender As Object, e As KeyPressEventArgs) Handles dropSize_TB.KeyPress
        If Asc(e.KeyChar) <> 13 AndAlso Asc(e.KeyChar) <> 8 AndAlso Not IsNumeric(e.KeyChar) Then
            e.Handled = True
        End If
    End Sub



    Private Sub delay_TB_Leave(sender As Object, e As EventArgs) Handles delay_TB.Leave
        formatValues()
    End Sub

    Private Sub numDrops_TB_Leave(sender As Object, e As EventArgs) Handles numDrops_TB.Leave
        formatValues()
    End Sub

    Private Sub dropSize_TB_Leave(sender As Object, e As EventArgs) Handles dropSize_TB.Leave
        formatValues()
    End Sub



    Private Sub formatValues()
        numDrops_TB.Text = Format(Val(numDrops_TB.Text), "00000")
        dropSize_TB.Text = Format(Val(dropSize_TB.Text), "00000")
        delay_TB.Text = Format(Val(delay_TB.Text), "00000")
    End Sub





    Public Function CheckSize(val As Long, low As Long, high As Long) As Long

        If (val < low) Then
            val = low
        End If
        If (val > high) Then
            val = high
        End If

        Return val
    End Function






    '    _____  ______  _______  _______  _____  _   _   _____   _____       _______         ____  
    '   / ____||  ____||__   __||__   __||_   _|| \ | | / ____| / ____|     |__   __| /\    |  _ \ 
    '  | (___  | |__      | |      | |     | |  |  \| || |  __ | (___          | |   /  \   | |_) |
    '   \___ \ |  __|     | |      | |     | |  | . ` || | |_ | \___ \         | |  / /\ \  |  _ < 
    '   ____) || |____    | |      | |    _| |_ | |\  || |__| | ____) |        | | / ____ \ | |_) |
    '  |_____/ |______|   |_|      |_|   |_____||_| \_| \_____||_____/         |_|/_/    \_\|____/ 



    Dim oldTab As Integer = 0
    Dim currentTab As Integer = 0


    Private Sub TabControl1_Selecting(sender As Object, e As TabControlCancelEventArgs) Handles GraphTabControl.Selecting

        If (e.TabPageIndex <> 1) Then
        Else
            oldTab = e.TabPageIndex
        End If

    End Sub


    Private Sub SETTINGS_Enter(sender As Object, e As EventArgs) Handles TAB_SETTINGS.Enter
        formatValues()
    End Sub


    Private Sub SETTINGS_Leave(sender As Object, e As EventArgs) Handles TAB_SETTINGS.Leave
        'closeValves()

    End Sub








    ''  _____                        _____        _    _    _                    
    '' / ____|                      / ____|      | |  | |  (_)                   
    ''| (___    __ _ __   __ ___   | (___    ___ | |_ | |_  _  _ __    __ _  ___ 
    '' \___ \  / _` |\ \ / // _ \   \___ \  / _ \| __|| __|| || '_ \  / _` |/ __|
    '' ____) || (_| | \ V /|  __/   ____) ||  __/| |_ | |_ | || | | || (_| |\__ \
    ''|_____/  \__,_|  \_/  \___|  |_____/  \___| \__| \__||_||_| |_| \__, ||___/
    ''                                                                 __/ |     
    ''                                                                |___/      

    Private Sub saveSettings()

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Enter saveSettings()" & vbCrLf)
        End If
        formatValues()


        Dim filename As String = "settings.txt"
        If (System.IO.File.Exists(filename) = False) Then
            System.IO.File.Create(filename).Dispose()
        End If
        Dim objWriter As New System.IO.StreamWriter(filename, False)

        Dim objCurrentDate As Date = DateTime.Today
        Dim currentDate As String = Format(objCurrentDate, "dd/MM/yyyy")
        Dim objCurrentTime As Date = TimeOfDay
        Format(DateTime.Today, "dd/MM/yyyy")

        objWriter.WriteLine("dropController: Settings File")
        objWriter.WriteLine("Saved: " & currentDate & " " & objCurrentTime)

        formatValues()
        objWriter.WriteLine("N=" + numDrops_TB.Text)
        objWriter.WriteLine("P=" + valvePort_CB.Text)
        objWriter.WriteLine("S=" + dropSize_TB.Text)
        objWriter.WriteLine("D=" + delay_TB.Text)

        objWriter.WriteLine("END")
        objWriter.Close()

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("  settings saved" & vbCrLf)
        End If

    End Sub





    '' _                        _     _____        _    _    _                    
    ''| |                      | |   / ____|      | |  | |  (_)                   
    ''| |      ___    __ _   __| |  | (___    ___ | |_ | |_  _  _ __    __ _  ___ 
    ''| |     / _ \  / _` | / _` |   \___ \  / _ \| __|| __|| || '_ \  / _` |/ __|
    ''| |____| (_) || (_| || (_| |   ____) ||  __/| |_ | |_ | || | | || (_| |\__ \
    ''|______|\___/  \__,_| \__,_|  |_____/  \___| \__| \__||_||_| |_| \__, ||___/
    ''                                                                  __/ |     
    ''                                                                 |___/      
    Public Sub loadSettings()

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Enter loadSettings()" & vbCrLf)
        End If


        Dim filename As String = "settings.txt"

        If Not System.IO.File.Exists(filename) Then
            ' file does not exist create new file
            saveSettings()

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("  settings file does not exist - new file created" & vbCrLf)
            End If

        End If


        Dim tmp As String = ""
        Dim foundPos As Integer = 0
        Dim found As Boolean = False


        Dim fileReader As System.IO.StreamReader
        fileReader = My.Computer.FileSystem.OpenTextFileReader(filename)

        ' file header
        tmp = fileReader.ReadLine()

        While tmp <> "END"
            tmp = fileReader.ReadLine()

            'if tmp contains "=" then parse
            foundPos = InStr(1, tmp, "=", CompareMethod.Text)
            If (foundPos > 0) Then

                Dim tmpSplit() As String = Split(tmp, "=", -1, CompareMethod.Text)

                If (DEBUG_MASTER) Then
                    debugTextBox.AppendText("    CMD=" & tmpSplit(0) & "  VAL=" & tmpSplit(1) & vbCrLf)
                End If


                If (tmpSplit(0) = "N") Then
                    If (Val(tmpSplit(1)) < 0 Or Val(tmpSplit(1)) > 99999) Then
                        tmpSplit(1) = "00000"
                    End If
                    numDrops_TB.Text = tmpSplit(1)
                    found = True
                End If


                If (tmpSplit(0) = "P") Then
                    If (Val(tmpSplit(1)) < 0 Or Val(tmpSplit(1)) > 6) Then
                        tmpSplit(1) = "1"
                    End If
                    valvePort_CB.Text = Val(tmpSplit(1))
                    found = True
                End If


                If (tmpSplit(0) = "S") Then
                        If (Val(tmpSplit(1)) < 0 Or Val(tmpSplit(1)) > 99999) Then
                            tmpSplit(1) = "00000"
                        End If
                        dropSize_TB.Text = tmpSplit(1)
                        found = True
                    End If


                    If (tmpSplit(0) = "D") Then
                        If (Val(tmpSplit(1)) < 0 Or Val(tmpSplit(1)) > 99999) Then
                            tmpSplit(1) = "00000"
                        End If
                        delay_TB.Text = tmpSplit(1)
                        found = True
                    End If


                    If (Not found) Then

                        If (DEBUG_MASTER) Then
                            debugTextBox.AppendText(tmp & " is not found" & vbCrLf)
                        End If

                    End If

                End If

        End While
        fileReader.Close()

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("  settings loaded" & vbCrLf)
        End If


        formatValues()

    End Sub







    '
    '  ____          _    _                                             _        
    ' |  _ \        | |  | |                                           | |       
    ' | |_) | _   _ | |_ | |_  ___   _ __       ___ __   __ ___  _ __  | |_  ___ 
    ' |  _ < | | | || __|| __|/ _ \ | '_ \     / _ \\ \ / // _ \| '_ \ | __|/ __|
    ' | |_) || |_| || |_ | |_| (_) || | | |   |  __/ \ V /|  __/| | | || |_ \__ \
    ' |____/  \__,_| \__| \__|\___/ |_| |_|    \___|  \_/  \___||_| |_| \__||___/
    '
    '

    Private Sub activateValveDrainButtons()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Enter activateValveDrainButtons()" & vbCrLf)
        End If

        Dim VD_BUT As Button() = New Button() {valve1Drain_BTN, valve1Drain_BTN, valve2Drain_BTN, valve3Drain_BTN, valve4Drain_BTN, valve5Drain_BTN, valve6Drain_BTN}
        For i As Integer = 1 To 6
            VD_BUT(i).Enabled = True
        Next i
    End Sub

    Private Sub disableValveDrainButtons()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Enter disableValveDrainButtons()" & vbCrLf)
        End If


        Dim VD_BUT As Button() = New Button() {valve1Drain_BTN, valve1Drain_BTN, valve2Drain_BTN, valve3Drain_BTN, valve4Drain_BTN, valve5Drain_BTN, valve6Drain_BTN}
        For i As Integer = 1 To 6
            VD_BUT(i).Enabled = False
        Next i
    End Sub



    Private Sub valve1Drain_BTN_Click(sender As Object, e As EventArgs) Handles valve1Drain_BTN.Click
        sendValveCommand(sender, 1)
    End Sub

    Private Sub valve2Drain_BTN_Click(sender As Object, e As EventArgs) Handles valve2Drain_BTN.Click
        sendValveCommand(sender, 2)
    End Sub

    Private Sub valve3Drain_BTN_Click(sender As Object, e As EventArgs) Handles valve3Drain_BTN.Click
        sendValveCommand(sender, 3)
    End Sub

    Private Sub valve4Drain_BTN_Click(sender As Object, e As EventArgs) Handles valve4Drain_BTN.Click
        sendValveCommand(sender, 4)
    End Sub

    Private Sub valve5Drain_BTN_Click(sender As Object, e As EventArgs) Handles valve5Drain_BTN.Click
        sendValveCommand(sender, 5)
    End Sub

    Private Sub valve6Drain_BTN_Click(sender As Object, e As EventArgs) Handles valve6Drain_BTN.Click
        sendValveCommand(sender, 6)
    End Sub


    Private Sub sendValveCommand(ByVal theClickedButton As Button, val As Integer)
        Dim command As String = ""

        If (theClickedButton.Text = "OPEN") Then
            theClickedButton.Text = "CLOSED"
            theClickedButton.BackColor = Color.FromArgb(255, 128, 128)

            command = "[V" & val & "0]"
        ElseIf (theClickedButton.Text = "CLOSED") Then
            theClickedButton.Text = "OPEN"
            theClickedButton.BackColor = Color.FromArgb(128, 255, 128)
            command = "[V" & val & "1]"
        End If

        sendCommand(command)
    End Sub



    Private Sub closeValves()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText(vbCrLf & "Enter closeValves()" & vbCrLf)
        End If


        If (SerialPort1.IsOpen) Then

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("serial port opened" & vbCrLf)
            End If

            sendCommand("[V10]")
            sendCommand("[V20]")
            sendCommand("[V30]")
            sendCommand("[V40]")
            sendCommand("[V50]")
            sendCommand("[V60]")

            If (DEBUG_MASTER) Then
                debugTextBox.AppendText(vbCrLf & "disableValveDrainButtons()" & vbCrLf)
            End If

            Dim VD_BUT As Button() = New Button() {valve1Drain_BTN, valve1Drain_BTN, valve2Drain_BTN, valve3Drain_BTN, valve4Drain_BTN, valve5Drain_BTN, valve6Drain_BTN}
            For i As Integer = 1 To 6
                VD_BUT(i).Text = "CLOSED"
                VD_BUT(i).BackColor = Color.FromArgb(255, 128, 128)
            Next i

        Else
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText(" serial port is closed - Valve close cmd not sent" & vbCrLf)
            End If
        End If
    End Sub









    ' _______  _____  __  __  ______  _____    _____ 
    '|__   __||_   _||  \/  ||  ____||  __ \  / ____|
    '   | |     | |  | \  / || |__   | |__) || (___  
    '   | |     | |  | |\/| ||  __|  |  _  /  \___ \ 
    '   | |    _| |_ | |  | || |____ | | \ \  ____) |
    '   |_|   |_____||_|  |_||______||_|  \_\|_____/ 


    Private Sub Timer_ConnectionTimeoutON()
        Timer_ConnectionTimeout.Enabled = True
        timerConnectFlag.Text = "ON"
    End Sub

    Private Sub Timer_ConnectionTimeoutOFF()
        Timer_ConnectionTimeout.Enabled = False
        timerConnectFlag.Text = "OFF"
    End Sub

    Private Sub Timer_recieveSerialDataOn()
        Timer_recieveSerialData.Enabled = True
        Timer_SD_IN_LBL.Text = "ON"
    End Sub

    Private Sub Timer_recieveSerialDataOff()
        Timer_recieveSerialData.Enabled = False
        Timer_SD_IN_LBL.Text = "OFF"
    End Sub


    Private Sub Timer_dropAckTimeoutON(val As Long)
        ' will need to add sequence value
        Timer_dropAckTimeout.Interval = val

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Timer_dropAckTimeout.Interval set to = " & val & vbCrLf)
            debugTextBox.AppendText("Timer_dropAckTimeout.Interval ON" & vbCrLf)
        End If
        Timer_dropAckTimeout.Enabled = True
        TimerACK_LBL.Text = "ON"
    End Sub

    Private Sub Timer_dropAckTimeoutOFF()
        Timer_dropAckTimeout.Enabled = False
        TimerACK_LBL.Text = "OFF"
    End Sub















    '  _____  _                _       ____          _    _                
    ' / ____|| |              | |     |  _ \        | |  | |               
    '| (___  | |_  __ _  _ __ | |_    | |_) | _   _ | |_ | |_  ___   _ __  
    ' \___ \ | __|/ _` || '__|| __|   |  _ < | | | || __|| __|/ _ \ | '_ \ 
    ' ____) || |_| (_| || |   | |_    | |_) || |_| || |_ | |_| (_) || | | |
    '|_____/  \__|\__,_||_|    \__|   |____/  \__,_| \__| \__|\___/ |_| |_|
    '
    '

    ' abort_BTN.Visible = False

    Private Sub startBTNoff()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Start_BTN OFF" & vbCrLf)
        End If

        MainStart_BTN.Text = "S T A R T "
        MainStart_BTN.Enabled = False
        MainStart_BTN.BackColor = Color.FromArgb(200, 220, 200)
    End Sub

    Private Sub startBTNon()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("MainStart_BTN ON" & vbCrLf)
        End If
        MainStart_BTN.Text = "S T A R T "
        MainStart_BTN.Enabled = True
        MainStart_BTN.BackColor = Color.FromArgb(128, 255, 128)
    End Sub



    Private Sub MainStart_BTN_Click_1(sender As Object, e As EventArgs) Handles MainStart_BTN.Click

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText(vbCrLf & "MainStart_BTN clicked" & vbCrLf)
        End If

        dropCount_LBL.ForeColor = Color.Black
        dropCount_LBL.Text = "0"

        receivedData = receivedData & GetSerialInData()
        receivedData = ""
        SerialPort1.DiscardInBuffer()
        Timer_recieveSerialDataOn()

        ' SEND DATA
        ' START TIMEOUT TIMER
        ' CHANGE TO ABORT


        ' disable MainStart_BTN
        ' enable ABORT button
        ' send data
        ' wait for ACK OR timeout: If time out show error message
        ' activate START button

        formatValues()

        start_time = Now

        sendCommand("[N" & numDrops_TB.Text & "]")
        sendCommand("[P" & Val(valvePort_CB.Text) & "]")
        sendCommand("[S" & dropSize_TB.Text & "]")
        sendCommand("[D" & delay_TB.Text & "]")
        sendCommand("[E]")

        'calculate timeout value. This is not enough when full debug is active on the dropControllerV3
        timeOutTime = Val(numDrops_TB.Text) * (Val(dropSize_TB.Text) + Val(delay_TB.Text)) + 10000

        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("timer timeout time = " & timeOutTime & vbCrLf)
        End If

        If (DEBUG2) Then
            DB1_LBL.Text = "time out = " & timeOutTime
        End If

        Timer_dropAckTimeoutON(timeOutTime)
        abort_BTN.Visible = True

    End Sub




    '        _                   _         _             _    _                
    '       | |                 | |       | |           | |  | |               
    '  __ _ | |__    ___   _ __ | |_      | |__   _   _ | |_ | |_  ___   _ __  
    ' / _` || '_ \  / _ \ | '__|| __|     | '_ \ | | | || __|| __|/ _ \ | '_ \ 
    '| (_| || |_) || (_) || |   | |_      | |_) || |_| || |_ | |_| (_) || | | |
    ' \__,_||_.__/  \___/ |_|    \__|     |_.__/  \__,_| \__| \__|\___/ |_| |_|
    '                                                                         
    '                                                                         

    Private Sub abort_BTN_Click(sender As Object, e As EventArgs) Handles abort_BTN.Click
        abort()
    End Sub


    Private Sub abort()
        sendCommand("[A]")
        dropCount_LBL.ForeColor = Color.Red
        initForNextDrop()
    End Sub




    ' _         _  _    ______            _   _              _    _____                     
    '(_)       (_)| |  |  ____|          | \ | |            | |  |  __ \                    
    ' _  _ __   _ | |_ | |__  ___   _ __ |  \| |  ___ __  __| |_ | |  | | _ __  ___   _ __  
    '| || '_ \ | || __||  __|/ _ \ | '__|| . ` | / _ \\ \/ /| __|| |  | || '__|/ _ \ | '_ \ 
    '| || | | || || |_ | |  | (_) || |   | |\  ||  __/ >  < | |_ | |__| || |  | (_) || |_) |
    '|_||_| |_||_| \__||_|   \___/ |_|   |_| \_| \___|/_/\_\ \__||_____/ |_|   \___/ | .__/ 
    '                                                                                | |    
    '                                                                                |_|    
    '
    Private Sub initForNextDrop()
        Timer_dropAckTimeoutOFF()
        Timer_recieveSerialDataOff()
        MainStart_BTN.Text = "S T A R T"
        MainStart_BTN.BackColor = Color.FromArgb(128, 255, 128)
        MainStart_BTN.Enabled = True
        abort_BTN.Visible = False
    End Sub







    '                       _   _____                                                _ 
    '                      | | / ____|                                              | |
    ' ___   ___  _ __    __| || |      ___   _ __ ___   _ __ ___    __ _  _ __    __| |
    '/ __| / _ \| '_ \  / _` || |     / _ \ | '_ ` _ \ | '_ ` _ \  / _` || '_ \  / _` |
    '\__ \|  __/| | | || (_| || |____| (_) || | | | | || | | | | || (_| || | | || (_| |
    '|___/ \___||_| |_| \__,_| \_____|\___/ |_| |_| |_||_| |_| |_| \__,_||_| |_| \__,_|
    '

    Private Sub sendCommand(command As String)
        If (SerialPort1.IsOpen) Then
            SerialPort1.Write(command)
            'SerialPort1.Write(vbCrLf)
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("sent command = " & command & vbCrLf)
            End If
        Else
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("command = " & command & vbCrLf)
                debugTextBox.AppendText("Serial port is closed!" & vbCrLf)
            End If

        End If
    End Sub



    Private Sub Timer_waitACK_Tick(sender As Object, e As EventArgs) Handles Timer_dropAckTimeout.Tick

        Timer_dropAckTimeoutOFF()
        If (DEBUG_MASTER) Then
            debugTextBox.AppendText("Timer_dropAckTimeout.Tick - drop Ack has timed out" & vbCrLf)
        End If
        MsgBox("No acknowledgement from the dropController. Do you want to continue?",, "ERROR")

        initForNextDrop()

    End Sub











    ' _____              _                       _____              _         _    _____          _         
    '|  __ \            (_)                     / ____|            (_)       | |  |  __ \        | |        
    '| |__) | ___   ___  _   ___ __   __ ___   | (___    ___  _ __  _   __ _ | |  | |  | |  __ _ | |_  __ _ 
    '|  _  / / _ \ / __|| | / _ \\ \ / // _ \   \___ \  / _ \| '__|| | / _` || |  | |  | | / _` || __|/ _` |
    '| | \ \|  __/| (__ | ||  __/ \ V /|  __/   ____) ||  __/| |   | || (_| || |  | |__| || (_| || |_| (_| |
    '|_|  \_\\___| \___||_| \___|  \_/  \___|  |_____/  \___||_|   |_| \__,_||_|  |_____/  \__,_| \__|\__,_|
    '

    ' CheckReceivedData()
#Region "recieveSerialData"

    Private Sub Timer_recieveSerialData_Tick(sender As Object, e As EventArgs) Handles Timer_recieveSerialData.Tick

        ' receivedData is the buffer used to store what ever data is received via the serial port
        Timer_recieveSerialDataOff()

        Dim Incoming As String = ""

        If (SerialPort1.IsOpen) Then
            Try
                Incoming = SerialPort1.ReadExisting()
                If Incoming Is Nothing Then
                    Incoming = ""
                End If
            Catch ex As TimeoutException
                Incoming = "Error: Serial Port read timed out."
            End Try

            If (Incoming = "Error: Serial Port read timed out.") Then
                MsgBox(Incoming, "COM PORT ERROR")
                Incoming = ""
            End If
        End If

        receivedData = receivedData + Incoming
        If (receivedData <> "") Then
            If (DEBUG_MASTER) Then
                debugTextBox.AppendText("RD=" & receivedData & vbCrLf)
            End If
        End If

        CheckReceivedData()

        Timer_recieveSerialDataOn()
    End Sub




    Private Sub CheckReceivedData()
        ' uses the global variable receivedData
        Dim pos1 As Integer
        Dim pos2 As Integer
        Dim length As Integer
        Dim newCommand As String
        Dim done As Boolean = False

        While (Not done)

            pos1 = receivedData.IndexOf("[") + 1
            pos2 = receivedData.IndexOf("]") + 1

            ' do we have a START MARKER and an END MARKER?
            If (pos1 = 0 Or pos2 = 0) Then
                ' we do not have both START and END MARKERS so we are done
                done = True
            End If


            If (Not done) Then

                ' We have a START MARKER and an END MARKER but are they in the correct order?
                ' Occasionally we may not get complete data and the end marker will be in front of the start marker
                ' for example "xx][xxxxx][xx"

                ' if pos2 <pos1 then remove the first part of the string from receivedData
                ' for example.  "xx][xxxxx][xx" to "[xxxxx][xx"

                If (pos1 <> 0 And pos2 <> 0) Then
                    If (pos2 < pos1) Then
                        receivedData = Microsoft.VisualBasic.Mid(receivedData, pos2 + 1)
                        pos1 = receivedData.IndexOf("[") + 1
                        pos2 = receivedData.IndexOf("]") + 1
                    End If
                End If

                ' We may have removed the only END MARKER so need to check again.
                ' This is not the best code but this way keeps the flow easy to see and makes it easier to edit.
                ' (The first check is not really required).


                pos1 = receivedData.IndexOf("[") + 1
                pos2 = receivedData.IndexOf("]") + 1

                If (pos1 = 0 Or pos2 = 0) Then
                    ' we do not have both start and end markers and we are done
                    done = True
                End If


            End If



            ' If we still have a START MARKER and an END MARKER we should have a command
            If (Not done) Then

                length = pos2 - pos1 + 1
                If (length > 0) Then

                    ' get the data from between the first START MARKER and the first END MARKER
                    newCommand = Mid(receivedData, pos1 + 1, length - 2)

                    'remove the command (including MARKERS)from receivedData
                    receivedData = Mid(receivedData, pos2 + 1)
                    If (DEBUG_MASTER) Then
                        debugTextBox.AppendText("New cmd = " & newCommand & vbCrLf)
                    End If



                    If (newCommand = "#") Then
                        stop_time = Now
                        elapsed_time = stop_time.Subtract(start_time)
                        Dim totalSecondsStr = elapsed_time.TotalSeconds.ToString("0.000000")

                        If (DEBUG_MASTER) Then
                            debugTextBox.AppendText("# received" & vbCrLf)
                            DB1_LBL.Text = "time out = " & timeOutTime
                            DB2_LBL.Text = "time taken = " & totalSecondsStr
                        End If
                        initForNextDrop()


                    ElseIf (newCommand = "HELLO") Then

                        ' HELLO received
                        Timer_ConnectionTimeoutOFF()

                        startBTNon()
                        refreshCOM_BTN.Enabled = False
                        connect_BTN.Text = "DIS-CONNECT"
                        connect_BTN.Enabled = True
                        COMport_CB.Enabled = False

                        activateValveDrainButtons()

                    ElseIf newCommand.StartsWith("C", StringComparison.OrdinalIgnoreCase) Then

                        Dim tmpSplit() As String = Split(newCommand, ",", -1, CompareMethod.Text)
                        dropCount_LBL.Text = tmpSplit(1)

                        If (DEBUG_MASTER) Then
                            debugTextBox.AppendText("count " & newCommand & vbCrLf)
                        End If

                    Else
                        If (DEBUG_MASTER) Then
                            debugTextBox.AppendText(">>  BAD COMMAND - " & newCommand & "<<" & vbCrLf)
                        End If

                    End If



                End If ' (length > 0) 

            End If


        End While

    End Sub





    Function GetSerialInData() As String

        Dim Incoming As String
        Try
            Incoming = SerialPort1.ReadExisting()
            If Incoming Is Nothing Then
                Return "nothing" & vbCrLf
            Else
                Return Incoming
            End If
        Catch ex As TimeoutException
            Return "Error: Serial Port read timed out."
        End Try

    End Function


#End Region ' "recieveSerialData"

























    ' _____         _                   
    '|  __ \       | |                  
    '| |  | |  ___ | |__   _   _   __ _ 
    '| |  | | / _ \| '_ \ | | | | / _` |
    '| |__| ||  __/| |_) || |_| || (_| |
    '|_____/  \___||_.__/  \__,_| \__, |
    '                              __/ |
    '                             |___/ 
    '

#Region "debug"


    Private Sub turnDebugOn()
        Me.Width = widthDebug
        debugTextBox.Visible = True
        checkConnected_Timer.Enabled = True
    End Sub

    Private Sub turnDebugOff()
        Me.Width = widthNormal
        debugTextBox.Visible = False
        checkConnected_Timer.Enabled = False
    End Sub





    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles checkConnected_Timer.Tick
        checkConnected_Timer.Enabled = False
        Dim tmp As Boolean
        tmp = SerialPort1.IsOpen
        If (tmp) Then
            Connected_Flag.Text = "TRUE"
        Else
            Connected_Flag.Text = "FALSE"
        End If
        checkConnected_Timer.Enabled = True
    End Sub




    Private Sub CLEAR_BTN_Click(sender As Object, e As EventArgs) Handles CLEAR_BTN.Click
        debugTextBox.Text = ""
    End Sub

    Private Sub closeDebug_BTN_Click(sender As Object, e As EventArgs) Handles closeDebug_BTN.Click
        turnDebugOff()
    End Sub

    '  Private Sub valvePort_CB_SelectedIndexChanged(sender As Object, e As EventArgs) Handles valvePort_CB.SelectedIndexChanged
    '      MsgBox("==" & valvePort_CB.Text & "==" & vbCrLf & "==" & Val(valvePort_CB.Text) & "==")
    '  End Sub






#End Region ' "debug"






End Class

